### *** This class provides Binary Compatibility only, not Source Compatibility ***

Package com.sas.services.storedprocess

# Class GenericStream

java.lang.Object
com.sas.services.storedprocess.GenericStream

All Implemented Interfaces:
  `com.sas.storage.editableproperties.LocalizableProperties`, `Serializable`

Direct Known Subclasses:
  `XMLStream`

@SASScope("ALL") @BinaryCompatibilityOnly public class GenericStream extends Object implements Serializable, com.sas.storage.editableproperties.LocalizableProperties
Describes a GenericStream data source or target. For data sources the properties of this object used by the Stored Process service are the fileref name and whether rewinding is allowed; for data targets only the fileref name is used. Other properties are solely for client use.

Since:
  9.2
See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final Element`
  `_streamElement`

  ### Fields inherited from interface com.sas.storage.editableproperties.LocalizableProperties

  `PROPERTY_DESCRIPTION, PROPERTY_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `allowsRewinds()`
  Determines whether the stream should allows rewinds.
  `String`
  `getDescription()`
  Returns the description.
  `String`
  `getExpectedContentType()`
  Returns the expected content type.
  `String`
  `getFileref()`
  Returns the SAS fileref name.
  `String`
  `getLabel()`
  Returns the label.
  `com.sas.storage.editableproperties.PropertyList`
  `getLocalizableProperties()`
  `boolean`
  `isSource()`
  True if this object is a data source; false if it's a data target.
  `void`
  `setLocalizableProperties(com.sas.storage.editableproperties.PropertyMap map)`
  `String`
  `toString()`
  Returns the fileref name.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### _streamElement

    protected final transient Element _streamElement

- ## Method Details

  - ### getFileref

    public String getFileref()
    Returns the SAS fileref name.
    Returns:
      the fileref name

  - ### getLabel

    public String getLabel()
    Returns the label.
    Returns:
      the label

  - ### getExpectedContentType

    public String getExpectedContentType()
    Returns the expected content type.
    Returns:
      the expected content type

  - ### allowsRewinds

    public boolean allowsRewinds() throws IllegalStateException
    Determines whether the stream should allows rewinds. If true, it does; if false, it does not. This method should only be called for data sources.
    Returns:
      whether the stream allows rewinds
    Throws:
      `IllegalStateException` - if called on a data target

  - ### getDescription

    public String getDescription()
    Returns the description.
    Returns:
      the description

  - ### toString

    public String toString()
    Returns the fileref name. This enables a GenericStream to be used as the parameter to `ExecutionBaseInterface.getInputStream(Object)` or `ExecutionBaseInterface.getOutputStream(Object)`.
    Overrides:
      `toString` in class `Object`

  - ### isSource

    public boolean isSource()
    True if this object is a data source; false if it's a data target.

  - ### getLocalizableProperties

    public com.sas.storage.editableproperties.PropertyList getLocalizableProperties()
    Specified by:
      `getLocalizableProperties` in interface `com.sas.storage.editableproperties.LocalizableProperties`

  - ### setLocalizableProperties

    public void setLocalizableProperties(com.sas.storage.editableproperties.PropertyMap map)
    Specified by:
      `setLocalizableProperties` in interface `com.sas.storage.editableproperties.LocalizableProperties`